<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\master_worker;


use app\common\model\master_worker\MasterWorker;
use app\common\model\master_worker\MasterWorkerAgree;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * MasterWorkerAgree逻辑
 * Class MasterWorkerAgreeLogic
 * @package app\adminapi\logic\master_worker
 */
class MasterWorkerAgreeLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            MasterWorkerAgree::create([
                'agree_type' => $params['agree_type'],
                'worker_id' => $params['worker_id'],
                'sign' => $params['sign'],
                'pdf_url' => $params['pdf_url'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            MasterWorkerAgree::where('id', $params['id'])->update([
                'audit_state' => $params['audit_state'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function delete(array $params): bool
    {
        return MasterWorkerAgree::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function detail($params): array
    {
        return MasterWorkerAgree::findOrEmpty($params['id'])->toArray();
    }

    public static function getWorkerIds($params): array
    {
        return MasterWorkerAgree::where('id',is_array($params['id'])?'in':'=',$params['id'])->column('worker_id');
    }

    public static function getStatus(): int
    {
        return MasterWorker::where('audit_state',0)->count();
    }


}